'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _enzyme = require('enzyme');

var _reactRouter = require('react-router');

var _RouterToUrlQuery = require('../RouterToUrlQuery');

var _RouterToUrlQuery2 = _interopRequireDefault(_RouterToUrlQuery);

var _urlQueryConfig = require('../../urlQueryConfig');

var _urlQueryConfig2 = _interopRequireDefault(_urlQueryConfig);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/* eslint-disable react/no-multi-comp */

describe('<RouterToUrlQuery />', function () {
  describe('with old style context (React Router < v5)', function () {
    it('reads router in from context and can push and replace', function () {
      var PutRouterInContext = function (_Component) {
        _inherits(PutRouterInContext, _Component);

        function PutRouterInContext() {
          _classCallCheck(this, PutRouterInContext);

          return _possibleConstructorReturn(this, (PutRouterInContext.__proto__ || Object.getPrototypeOf(PutRouterInContext)).apply(this, arguments));
        }

        _createClass(PutRouterInContext, [{
          key: 'getChildContext',


          // eslint-disable-next-line
          value: function getChildContext() {
            return {
              router: {
                replace: jest.fn().mockImplementation(function (location) {
                  return location;
                }),
                push: jest.fn().mockImplementation(function (location) {
                  return location;
                })
              }
            };
          }
        }, {
          key: 'render',
          value: function render() {
            return _react2.default.Children.only(this.props.children);
          }
        }]);

        return PutRouterInContext;
      }(_react.Component);

      PutRouterInContext.propTypes = {
        children: _propTypes2.default.node
      };
      PutRouterInContext.childContextTypes = {
        router: _propTypes2.default.object
      };


      var wrapper = (0, _enzyme.mount)(_react2.default.createElement(
        PutRouterInContext,
        null,
        _react2.default.createElement(
          _RouterToUrlQuery2.default,
          null,
          _react2.default.createElement('div', { className: 'test' })
        )
      ));

      expect(wrapper.contains(_react2.default.createElement('div', { className: 'test' }))).toBe(true);

      expect(_urlQueryConfig2.default.history).toBeDefined();
      expect(_urlQueryConfig2.default.history.push).toBeDefined();
      expect(_urlQueryConfig2.default.history.replace).toBeDefined();

      _urlQueryConfig2.default.history.push();
      expect(_urlQueryConfig2.default.history.push).toBeCalled();

      _urlQueryConfig2.default.history.replace();
      expect(_urlQueryConfig2.default.history.replace).toBeCalled();
    });

    it('reads router in from context and can push and replace when router has transitionTo and replaceWith', function () {
      var PutRouterInContext = function (_Component2) {
        _inherits(PutRouterInContext, _Component2);

        function PutRouterInContext() {
          _classCallCheck(this, PutRouterInContext);

          return _possibleConstructorReturn(this, (PutRouterInContext.__proto__ || Object.getPrototypeOf(PutRouterInContext)).apply(this, arguments));
        }

        _createClass(PutRouterInContext, [{
          key: 'getChildContext',


          // eslint-disable-next-line
          value: function getChildContext() {
            return {
              router: {
                replaceWith: jest.fn().mockImplementation(function (location) {
                  return location;
                }),
                transitionTo: jest.fn().mockImplementation(function (location) {
                  return location;
                })
              }
            };
          }
        }, {
          key: 'render',
          value: function render() {
            return _react2.default.Children.only(this.props.children);
          }
        }]);

        return PutRouterInContext;
      }(_react.Component);

      PutRouterInContext.propTypes = {
        children: _propTypes2.default.node
      };
      PutRouterInContext.childContextTypes = {
        router: _propTypes2.default.object
      };


      var wrapper = (0, _enzyme.mount)(_react2.default.createElement(
        PutRouterInContext,
        null,
        _react2.default.createElement(
          _RouterToUrlQuery2.default,
          null,
          _react2.default.createElement('div', { className: 'test' })
        )
      ));

      expect(wrapper.contains(_react2.default.createElement('div', { className: 'test' }))).toBe(true);

      expect(_urlQueryConfig2.default.history).toBeDefined();
      expect(_urlQueryConfig2.default.history.push).toBeDefined();
      expect(_urlQueryConfig2.default.history.replace).toBeDefined();

      _urlQueryConfig2.default.history.push();
      expect(_urlQueryConfig2.default.history.push).toBeCalled();

      _urlQueryConfig2.default.history.replace();
      expect(_urlQueryConfig2.default.history.replace).toBeCalled();
    });
  });

  describe('with new style context (React Router v5+)', function () {
    it('reads router in from context and can push and replace', function () {
      var wrapper = (0, _enzyme.mount)(_react2.default.createElement(
        _reactRouter.__RouterContext.Provider,
        { value: {
            replace: jest.fn().mockImplementation(function (location) {
              return location;
            }),
            push: jest.fn().mockImplementation(function (location) {
              return location;
            })
          } },
        _react2.default.createElement(
          _RouterToUrlQuery2.default,
          { routerContext: _reactRouter.__RouterContext },
          _react2.default.createElement('div', { className: 'test' })
        )
      ));

      expect(wrapper.contains(_react2.default.createElement('div', { className: 'test' }))).toBe(true);

      expect(_urlQueryConfig2.default.history).toBeDefined();
      expect(_urlQueryConfig2.default.history.push).toBeDefined();
      expect(_urlQueryConfig2.default.history.replace).toBeDefined();

      _urlQueryConfig2.default.history.push();
      expect(_urlQueryConfig2.default.history.push).toBeCalled();

      _urlQueryConfig2.default.history.replace();
      expect(_urlQueryConfig2.default.history.replace).toBeCalled();
    });

    it('reads router in from context and can push and replace when router has transitionTo and replaceWith', function () {
      var wrapper = (0, _enzyme.mount)(_react2.default.createElement(
        _reactRouter.__RouterContext.Provider,
        { value: {
            replaceWith: jest.fn().mockImplementation(function (location) {
              return location;
            }),
            transitionTo: jest.fn().mockImplementation(function (location) {
              return location;
            })
          } },
        _react2.default.createElement(
          _RouterToUrlQuery2.default,
          { routerContext: _reactRouter.__RouterContext },
          _react2.default.createElement('div', { className: 'test' })
        )
      ));

      expect(wrapper.contains(_react2.default.createElement('div', { className: 'test' }))).toBe(true);

      expect(_urlQueryConfig2.default.history).toBeDefined();
      expect(_urlQueryConfig2.default.history.push).toBeDefined();
      expect(_urlQueryConfig2.default.history.replace).toBeDefined();

      _urlQueryConfig2.default.history.push();
      expect(_urlQueryConfig2.default.history.push).toBeCalled();

      _urlQueryConfig2.default.history.replace();
      expect(_urlQueryConfig2.default.history.replace).toBeCalled();
    });
  });
});